poj 2002 Squares

2024-04-29 13:48
文章标签 poj 2002 squares

本文主要是介绍poj 2002 Squares,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目链接:点击打开链接

Description

A square is a 4-sided polygon whose sides have equal length and adjacent sides form 90-degree angles. It is also a polygon such that rotating about its centre by 90 degrees gives the same polygon. It is not the only polygon with the latter property, however, as a regular octagon also has this property. 

So we all know what a square looks like, but can we find all possible squares that can be formed from a set of stars in a night sky? To make the problem easier, we will assume that the night sky is a 2-dimensional plane, and each star is specified by its x and y coordinates. 

Input

The input consists of a number of test cases. Each test case starts with the integer n (1 <= n <= 1000) indicating the number of points to follow. Each of the next n lines specify the x and y coordinates (two integers) of each point. You may assume that the points are distinct and the magnitudes of the coordinates are less than 20000. The input is terminated when n = 0.

Output

For each test case, print on a line the number of squares one can form from the given stars.

Sample Input

4
1 0
0 1
1 1
0 0
9
0 0
1 0
2 0
0 2
1 2
2 2
0 1
1 1
2 1
4
-2 5
3 7
0 0
5 2
0

Sample Output

1
6
1
题目大意:给出不同的坐标点,问能做成正方形的个数,对于同四个点不同起点的正方形算一个.
基本思路:先定义一个结构体存坐标,压在数学中由知道正方形的两个点就能确定另外两个点可能的位置,这样就只暴力两个点,否则就超时了;
公式:
已知两坐标(x1,y1)(x2,y2)
x3=x1+(y1-y2);y3=y1-(x1-x2);
x4=x2+(y1-y2);y4=y2-(x1-x2);
或:
x3=x1-(y1-y2);y3=y1+(x1-x2);
x4=x2-(y1-y2);y4=y2+(x1-x2);
然后就是hash查找是否存在另外的两点.以前用过hash拉链法,觉的好用就一直用这个(Vector存储的).对坐标的和hash,将点的序列存进去.
在取余时要注意它的效率问题.
这里定义了两个hash,一个存正数,一个存负数.
因为对每两个点暴力了一下,会用重复的所以最后要除4

<span style="font-size:24px;">#include <iostream>
#define prime 40005
#include<vector>
#include<cstring>
#include<cstdlib>using namespace std;
struct node
{int x,y;
} point[2005];vector<int >hash1[prime],hash2[prime];int search(int x,int y)
{int sum=x+y;if(sum>=0){sum=sum%prime;int len=hash1[sum].size();for(int i=0; i<len; i++){if(x==point[hash1[sum][i]].x&&y==point[hash1[sum][i]].y){return true;}}}else{sum=-1*sum;sum=sum%prime;int len=hash2[sum].size();for(int i=0; i<len; i++){if(x==point[hash2[sum][i]].x&&y==point[hash2[sum][i]].y){return true;}}}return false;
}
int main()
{int n;while(cin>>n,n){for(int i=0; i<prime; i++){hash1[i].clear();hash2[i].clear();}for(int i=0; i<n; i++){cin>>point[i].x>>point[i].y;int sum=point[i].x+point[i].y;if(sum>=0){sum=sum%prime;hash1[sum].push_back(i);}else{sum=-1*sum;sum=sum%prime;hash2[sum].push_back(i);}}int x1,x2,y1,y2,ans=0;for(int i=0; i<n; i++){for(int j=i+1; j<n; j++){if(i==j)continue;x1=point[i].x+(point[i].y-point[j].y);y1=point[i].y-(point[i].x-point[j].x);x2=point[j].x+(point[i].y-point[j].y);y2=point[j].y-(point[i].x-point[j].x);if(search(x1,y1)&&search(x2,y2)){ans++;}x1=point[i].x-(point[i].y-point[j].y);y1=point[i].y+(point[i].x-point[j].x);x2=point[j].x-(point[i].y-point[j].y);y2=point[j].y+(point[i].x-point[j].x);if(search(x1,y1)&&search(x2,y2)){ans++;}}}cout<<ans/4<<endl;}return 0;
}
</span>



这篇关于poj 2002 Squares的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/946256

相关文章

usaco 1.2 Palindromic Squares(进制转化)

考察进制转化 注意一些细节就可以了 直接上代码: /*ID: who jayLANG: C++TASK: palsquare*/#include<stdio.h>int x[20],xlen,y[20],ylen,B;void change(int n){int m;m=n;xlen=0;while(m){x[++xlen]=m%B;m/=B;}m=n*n;ylen=0;whi

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一